# coding: utf-8

"""
    Snowflake Database API

    The Snowflake Database API is a REST API that you can use to access, update, and perform certain actions on Database resource in Snowflake.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json
import snowflake.core.database._generated.models
from snowflake.core.database._generated.models import *


from typing import Optional, Union
from typing import Union
from snowflake.core._internal.pydantic_compatibility import BaseModel, Field, StrictStr

class PointOfTime(BaseModel):
    point_of_time_type: Optional[StrictStr] = None
    reference: Optional[StrictStr] = Field(None, description="The relation to the point of time. At the time of writing at and before are supported.")
    when: Optional[StrictStr] = Field(None, description="The actual description of the point of time.")
    __properties = ["point_of_time_type", "reference", "when"]


    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    # JSON field name that stores the object type
    __discriminator_property_name = 'point_of_time_type'

    # discriminator mappings
    __discriminator_value_class_map = {
        'offset': 'PointOfTimeOffset',
        'statement': 'PointOfTimeStatement',
        'timestamp': 'PointOfTimeTimestamp'
    }

    @classmethod
    def get_discriminator_value(cls, obj: dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None


    __discriminator_value_to_type = {
        'PointOfTimeOffset': 'offset',
        'PointOfTimeStatement': 'statement',
        'PointOfTimeTimestamp': 'timestamp',
    }

    @classmethod
    def get_child_model_discriminator_value(cls, child_model: str) -> str:
        return cls.__discriminator_value_to_type[child_model]


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union[PointOfTimeOffset, PointOfTimeStatement, PointOfTimeTimestamp]:
        """Create an instance of PointOfTime from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Union[PointOfTimeOffset, PointOfTimeStatement, PointOfTimeTimestamp]:
        """Create an instance of PointOfTime from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = getattr(snowflake.core.database._generated.models, object_type)
            return klass.from_dict(obj)
        else:
            raise ValueError("PointOfTime failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))


from typing import Optional, List, Dict

class PointOfTimeModel():
    def __init__(
        self,
        # optional properties
        point_of_time_type: Optional[str] = None,
        reference: Optional[str] = None,
        when: Optional[str] = None,
    ):
        self.point_of_time_type = point_of_time_type
        self.reference = reference
        self.when = when
    __properties = ["point_of_time_type", "reference", "when"]

    def _to_model(self):
        return PointOfTime(
            
            reference=self.reference,

            when=self.when,

        )

    @classmethod
    def _from_model(cls, model) -> PointOfTimeModel:
        return model.__class__._model_class._from_model(model)

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> Union(PointOfTimeOffsetModel, PointOfTimeStatementModel, PointOfTimeTimestampModel):
        """Create an instance of PointOfTime from a dict"""
        return cls._from_model(PointOfTime.from_dict(obj))


PointOfTime._model_class = PointOfTimeModel
