# snowflake.core.task.-generated
The Snowflake Task API is a REST API that you can use to access, update, and perform certain actions on task resources in a Snowflake database.

The `snowflake.core.task._generated` package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.1
- Package version: 1.0.0
- Build package: com.snowflake.generator.pyapi.PyapiCodegenGenerator
For more information, please visit [https://snowflake.com](https://snowflake.com)

## Requirements.

Python 3.7+

## Installation & Usage

This python library package is generated without supporting files like setup.py or requirements files

To be able to use it, you will need these dependencies in your own package that uses this library:

* urllib3 >= 1.25.3
* python-dateutil
* pydantic

## Getting Started

In your own code, to use this library to connect and interact with snowflake.core.task.-generated,
you can run the following:

```python
from __future__ import print_function

import time
import snowflake.core.task._generated
from snowflake.core.task._generated.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://org-account.snowflakecomputing.com
# See configuration.py for a list of all supported configuration parameters.
configuration = snowflake.core.task._generated.Configuration(
    host = "https://org-account.snowflakecomputing.com"
)



# Enter a context with an instance of the API client
with snowflake.core.task._generated.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = snowflake.core.task._generated.TaskApi(api_client)
    database = 'database_example' # str | 
    var_schema = 'var_schema_example' # str | 
    name = 'name_example' # str | 
    task = snowflake.core.task._generated.Task() # Task | 

    try:
        # Create a (or alter an existing) task
        api_response = api_instance.create_or_alter_task(database, var_schema, name, task)
        print("The response of TaskApi->create_or_alter_task:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling TaskApi->create_or_alter_task: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://org-account.snowflakecomputing.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*TaskApi* | [**create_or_alter_task**](_generated/docs/TaskApi.md#create_or_alter_task) | **PUT** /api/v2/databases/{database}/schemas/{schema}/tasks/{name} | Create a (or alter an existing) task
*TaskApi* | [**create_task**](_generated/docs/TaskApi.md#create_task) | **POST** /api/v2/databases/{database}/schemas/{schema}/tasks | Create a task
*TaskApi* | [**delete_task**](_generated/docs/TaskApi.md#delete_task) | **DELETE** /api/v2/databases/{database}/schemas/{schema}/tasks/{name} | Delete a task
*TaskApi* | [**execute_task**](_generated/docs/TaskApi.md#execute_task) | **POST** /api/v2/databases/{database}/schemas/{schema}/tasks/{name}:execute | Execute a task object.
*TaskApi* | [**fetch_task**](_generated/docs/TaskApi.md#fetch_task) | **GET** /api/v2/databases/{database}/schemas/{schema}/tasks/{name} | Fetch a task
*TaskApi* | [**fetch_task_dependents**](_generated/docs/TaskApi.md#fetch_task_dependents) | **GET** /api/v2/databases/{database}/schemas/{schema}/tasks/{name}/dependents | Fetch the dependent tasks of a task
*TaskApi* | [**get_complete_graphs**](_generated/docs/TaskApi.md#get_complete_graphs) | **GET** /api/v2/databases/{database}/schemas/{schema}/tasks/{name}/complete_graphs | Get the graph runs that are completed for the task.
*TaskApi* | [**get_current_graphs**](_generated/docs/TaskApi.md#get_current_graphs) | **GET** /api/v2/databases/{database}/schemas/{schema}/tasks/{name}/current_graphs | Get the graph runs that are executing or scheduled for the task for the next 8 days.
*TaskApi* | [**list_tasks**](_generated/docs/TaskApi.md#list_tasks) | **GET** /api/v2/databases/{database}/schemas/{schema}/tasks | List tasks
*TaskApi* | [**resume_task**](_generated/docs/TaskApi.md#resume_task) | **POST** /api/v2/databases/{database}/schemas/{schema}/tasks/{name}:resume | Resume a suspended task.
*TaskApi* | [**suspend_task**](_generated/docs/TaskApi.md#suspend_task) | **POST** /api/v2/databases/{database}/schemas/{schema}/tasks/{name}:suspend | Suspends a running task.


## Documentation For Models

 - [CronSchedule](_generated/docs/CronSchedule.md)
 - [ErrorResponse](_generated/docs/ErrorResponse.md)
 - [MinutesSchedule](_generated/docs/MinutesSchedule.md)
 - [SuccessResponse](_generated/docs/SuccessResponse.md)
 - [Task](_generated/docs/Task.md)
 - [TaskRun](_generated/docs/TaskRun.md)
 - [TaskSchedule](_generated/docs/TaskSchedule.md)


## Documentation For SDK Exceptions

Class | Description
------------ | -------------
_APITypeError | Thrown when unrecognized arguments are passed to the generated API functions
_APIValueError | Thrown when arguments do not match HTTP method types. Or HTTP method type is not valid
ApiException | Thrown if status code is not success. Or if the response body cannot be deserialized
NotFoundException | Thrown if response.status = 404
UnauthorizedException | Thrown if response.status = 401
ForbiddenException | Thrown if response.status = 403
ServiceException | Thrown if 500 <= response.status <= 599

## Documentation For Authorization

 All endpoints do not require authorization.

## Author

support@snowflake.com


